﻿Imports System.Drawing.Printing
Public Class Hics213Frm
    '    Copyright (c) <2013> <John Joseph Blowsky>
    'Permission is hereby granted, free of charge, to any person obtaining a copy
    ' of this software and associated documentation files (the "Software"), to deal
    ' in the Software without restriction, including without limitation the rights
    ' to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
    ' copies of the Software, and to permit persons to whom the Software is
    ' furnished to do so, subject to the following conditions:

    'The above copyright notice and this permission notice shall be included in
    ' all copies or substantial portions of the Software.

    'THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
    ' IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
    ' FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
    ' AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
    ' LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
    ' OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
    ' THE SOFTWARE.

    Private Sub ReplyNoOpt_Click(sender As Object, e As EventArgs) Handles ReplyNoOpt.Click
        If ReplyNoOpt.Checked = True Then
            ReplyToTxt.Text = Nothing
            ReplyToTxt.Enabled = False
        End If
    End Sub

    Private Sub ReplyYesOpt_Click(sender As Object, e As EventArgs) Handles ReplyYesOpt.Click
        If ReplyYesOpt.Checked = True Then ReplyToTxt.Enabled = True
    End Sub

    Private Sub Hics_213Frm_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        UtcLocalFrm.Dispose()
        HelpFrm.Dispose()
    End Sub

    Private Sub Hics_213Frm_Load(sender As Object, e As EventArgs) Handles Me.Load
        Dim Sans As String = Nothing
        Dim FileIndex As Integer
        Dim InRecord As String

        If Not My.Computer.FileSystem.DirectoryExists(DataDirPath & "\formsgin") Then _
          My.Computer.FileSystem.CreateDirectory(DataDirPath & "\formsgin")

        If Not My.Computer.FileSystem.DirectoryExists(DataDirPath & "\formsgout") Then _
          My.Computer.FileSystem.CreateDirectory(DataDirPath & "\formsgout")

        If My.Computer.FileSystem.FileExists(DataDirPath & "\HICS.ini") Then
            FileIndex = FreeFile()
            FileOpen(FileIndex, DataDirPath & "\HICS.ini", OpenMode.Input)
            InRecord = LineInput(FileIndex)
            FileClose(FileIndex)
            If InRecord <> "015" Then
                Kill(DataDirPath & "\HICS.ini")
                MsgBox("HICS-213 has found an old HICS.ini file." & vbCrLf & " The most likely cause is I have changed the format of the .ini file." & vbCrLf & "HICS-213 will now delete the old non valid .ini file and the setup dialog will be displayed.", MsgBoxStyle.Information, "HICS-213 old .ini file found")
            End If
        End If

        If Not My.Computer.FileSystem.FileExists(DataDirPath & "\HICS.ini") Then
            UtcLocalFrm.ShowDialog()
            Select Case UtcLocalFrm.DialogResult
                Case DialogResult.Yes  'UTC
                    DateTimeFlag = "UTC Date Time"
                Case DialogResult.No  'LOCAL
                    DateTimeFlag = "LOCAL Date Time"
            End Select
            FileIndex = FreeFile()
            FileOpen(FileIndex, DataDirPath & "\HICS.ini", OpenMode.Output)
            PrintLine(FileIndex, "015")
            PrintLine(FileIndex, DateTimeFlag)
            FileClose(FileIndex)
        Else
            FileIndex = FreeFile()
            FileOpen(FileIndex, DataDirPath & "\HICS.ini", OpenMode.Input)
            InRecord = LineInput(FileIndex)
            DateTimeFlag = LineInput(FileIndex)
            FileClose(FileIndex)
        End If

        Me.Text = "HICS 213 – INCIDENT MESSAGE FORM Version " & Application.ProductVersion


        PrintDocument1.DefaultPageSettings.Landscape = False
        PrintDocument1.OriginAtMargins = True

        PrintPreviewDialog1.WindowState = FormWindowState.Maximized
        PrintPreviewDialog1.PrintPreviewControl.Zoom = 1.0
        PrintPreviewDialog1.Document = PrintDocument1

        '        PrecCombo.SelectedIndex = 0
        TextHasChanged = False

    End Sub

    Private Sub OpenMenu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenMenu.Click

        Dim FileIndex As Short
        Dim x As Long
        Dim y As Long
        Dim InRecord As String
        Dim FoundItFlag As Boolean = False

        OpenFileDialog1.Title = "HICS-213 Open ICS-213 Form"
        OpenFileDialog1.Filter = "HICS-213 Forms|*.ics"
        OpenFileDialog1.ValidateNames = True
        OpenFileDialog1.InitialDirectory = DataDirPath
        If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            Call MyErase()
            AttchFileNamePath = OpenFileDialog1.FileName
            FileIndex = FreeFile()
            FileOpen(FileIndex, OpenFileDialog1.FileName, OpenMode.Input)
            IncNameTxt.Text = LineInput(FileIndex)
            MsgNoTxt.Text = LineInput(FileIndex)
            FromTxt.Text = LineInput(FileIndex)
            ToTxt.Text = LineInput(FileIndex)
            InRecord = LineInput(FileIndex)
            If InRecord <> "NONE" Then DateTxt.Text = InRecord
            InRecord = LineInput(FileIndex)
            If InRecord <> "NONE" Then TimeTxt.Text = InRecord
            InRecord = LineInput(FileIndex)
            If InRecord <> "NONE" Then
                If InRecord = "PHONE" Then PhoneOpt.Checked = True
                If InRecord = "RADIO" Then RadioOpt.Checked = True
                If InRecord = "OTHER" Then OtherOpt.Checked = True
            End If
            InRecord = LineInput(FileIndex)
            If InRecord <> "NO" Then
                ReplyYesOpt.Checked = True
                ReplyToTxt.Enabled = True
            Else
                ReplyNoOpt.Checked = True
            End If
            InRecord = LineInput(FileIndex)
            If InRecord <> "NONE" Then ReplyToTxt.Text = InRecord
            InRecord = LineInput(FileIndex)
            If InRecord = "HIGH" Then UrgentOpt.Checked = True
            If InRecord = "MEDIUM" Then NonUrgentOpt.Checked = True
            If InRecord = "LOW" Then InformationalLowOpt.Checked = True
            y = LineInput(FileIndex)
            If y > 0 Then
                For x = 1 To y
                    MsgTxt.AppendText(LineInput(FileIndex) & vbCrLf)
                Next
                MsgTxt.Text = Mid(MsgTxt.Text, 1, Len(MsgTxt.Text) - 2)
            End If
            y = LineInput(FileIndex)
            If y > 0 Then
                For x = 1 To y
                    ActionTxt.AppendText(LineInput(FileIndex) & vbCrLf)
                Next
                ActionTxt.Text = Mid(ActionTxt.Text, 1, Len(ActionTxt.Text) - 2)
            End If
            InRecord = LineInput(FileIndex)
            If InRecord <> "NONE" Then ReceivedByTxt.Text = InRecord
            InRecord = LineInput(FileIndex)
            If InRecord <> "NONE" Then TimeRecTxt.Text = InRecord
            InRecord = LineInput(FileIndex)
            If InRecord <> "NONE" Then FwdToTxt.Text = InRecord
            y = LineInput(FileIndex)
            If y > 0 Then
                For x = 1 To y
                    CommentsTxt.AppendText(LineInput(FileIndex) & vbCrLf)
                Next
                CommentsTxt.Text = Mid(CommentsTxt.Text, 1, Len(CommentsTxt.Text) - 2)
            End If
            InRecord = LineInput(FileIndex)
            If InRecord <> "NONE" Then FacilityTxt.Text = InRecord
            MyFileName = OpenFileDialog1.FileName
            FileClose(FileIndex)
            TextHasChanged = False
        End If
    End Sub

    Private Sub MyErase()
        MsgNoTxt.Text = Nothing
        FromTxt.Text = Nothing
        ToTxt.Text = Nothing
        DateTxt.Text = Nothing
        TimeTxt.Text = Nothing
        PhoneOpt.Checked = False
        RadioOpt.Checked = False
        OtherOpt.Checked = False
        ReplyYesOpt.Checked = False
        ReplyNoOpt.Checked = True
        ReplyToTxt.Text = Nothing
        ReplyToTxt.Enabled = False
        UrgentOpt.Checked = False
        NonUrgentOpt.Checked = False
        InformationalLowOpt.Checked = False
        MsgTxt.Text = Nothing
        ActionTxt.Text = Nothing
        ReceivedByTxt.Text = Nothing
        TimeRecTxt.Text = Nothing
        FwdToTxt.Text = Nothing
        CommentsTxt.Text = Nothing
        FacilityTxt.Text = Nothing
        TextHasChanged = False
    End Sub

    Private Sub SaveMenu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveMenu.Click
        Dim Sans As Boolean = False
        Sans = SaveICS()
        If Sans Then Call MyErase()
    End Sub

    Private Function SaveICS() As Boolean
        Dim FileIndex As Short

        If IncNameTxt.Text = "" Then
            MsgBox("You first have to enter the Incident Name. Please do so now and try again.", MsgBoxStyle.Information, "HICS-213 Incident field missing")
            SaveICS = False
            Exit Function
        End If
        If MsgNoTxt.Text = "" Then
            MsgBox("You first have to enter the Message Number. Please do so now and try again.", MsgBoxStyle.Information, "HICS-213 Message Number field missing")
            SaveICS = False
            Exit Function
        End If
        If FromTxt.Text = "" Then
            MsgBox("You first have to enter the From Field. Please do so now and try again.", MsgBoxStyle.Information, "HICS-213 From field missing")
            SaveICS = False
            Exit Function
        End If
        If ToTxt.Text = "" Then
            MsgBox("You first have to enter the To field. Please do so now and try again.", MsgBoxStyle.Information, "HICS-213 To field missing")
            SaveICS = False
            Exit Function
        End If
        'If DateTxt.Text = "" Then
        '    MsgBox("You first have to enter the Date field. Please do so now and try again.", MsgBoxStyle.Information, "HICS-213 Date field missing")
        '    SaveICS = False
        '    Exit Function
        'End If
        'If TimeTxt.Text = "" Then
        '    MsgBox("You first have to enter the Time field. Please do so now and try again.", MsgBoxStyle.Information, "HICS-213 Time field missing")
        '    SaveICS = False
        '    Exit Function
        'End If
        'If PhoneOpt.Checked = False And RadioOpt.Checked = False And OtherOpt.Checked = False Then
        '    MsgBox("You first have to select one of the Received Via Choices. Please do so now and try again.", MsgBoxStyle.Information, "HICS-213 No Received Via choice")
        '    SaveICS = False
        '    Exit Function
        'End If
        'If ReplyYesOpt.Checked = False And ReplyNoOpt.Checked = False Then
        '    MsgBox("You first have to select one of the Reply Requested Choices. Please do so now and try again.", MsgBoxStyle.Information, "HICS-213 No Reply Requested choice")
        '    SaveICS = False
        '    Exit Function
        'End If
        'If ReplyYesOpt.Checked = True And ReplyToTxt.Text = Nothing Then
        '    MsgBox("You have slected Yes to the Reply To question so you need to fill in the Reply to field. Please do so now and try again.", MsgBoxStyle.Information, "HICS-213 Reply Requested choice")
        '    SaveICS = False
        '    Exit Function
        'End If
        If UrgentOpt.Checked = False And NonUrgentOpt.Checked = False And InformationalLowOpt.Checked = False Then
            MsgBox("You first have to select one of the PRIORITY Choices. Please do so now and try again.", MsgBoxStyle.Information, "HICS-213 No PRIORITY choice")
            SaveICS = False
            Exit Function
        End If
        If MsgTxt.Text = "" Then
            MsgBox("You first have to enter a message. Please do so now and try again.", MsgBoxStyle.Information, "HICS-213 Message missing")
            SaveICS = False
            Exit Function
        End If
        If FacilityTxt.Text = "" Then
            MsgBox("You first have to enter Facility Name. Please do so now and try again.", MsgBoxStyle.Information, "HICS-213 Facility Name missing")
            SaveICS = False
            Exit Function
        End If
        SaveFileDialog1.Title = "HICS-213 Save ICS-213 Form"
        SaveFileDialog1.Filter = "ICS-213 Forms|*.ics"
        SaveFileDialog1.ValidateNames = True
        SaveFileDialog1.InitialDirectory = DataDirPath
        SaveFileDialog1.FileName = MsgNoTxt.Text & IncNameTxt.Text
        If SaveFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            AttchFileNamePath = SaveFileDialog1.FileName
            FileIndex = FreeFile()
            FileOpen(FileIndex, SaveFileDialog1.FileName, OpenMode.Output)
            MyFileName = SaveFileDialog1.FileName
            PrintLine(FileIndex, IncNameTxt.Text)
            PrintLine(FileIndex, MsgNoTxt.Text)
            PrintLine(FileIndex, FromTxt.Text)
            PrintLine(FileIndex, ToTxt.Text)
            If DateTxt.Text = "" Then
                PrintLine(FileIndex, "NONE")
            Else
                PrintLine(FileIndex, DateTxt.Text)
            End If
            If TimeTxt.Text = "" Then
                PrintLine(FileIndex, "NONE")
            Else
                PrintLine(FileIndex, TimeTxt.Text)
            End If
            If PhoneOpt.Checked = True Then
                PrintLine(FileIndex, "PHONE")
            ElseIf RadioOpt.Checked = True Then
                PrintLine(FileIndex, "RADIO")
            ElseIf OtherOpt.Checked = True Then
                PrintLine(FileIndex, "OTHER")
            Else
                PrintLine(FileIndex, "NONE")
            End If
            If ReplyYesOpt.Checked = True Then
                PrintLine(FileIndex, "YES")
            Else
                PrintLine(FileIndex, "NO")
            End If
            If ReplyToTxt.Text <> "" Then
                PrintLine(FileIndex, ReplyToTxt.Text)
            Else
                PrintLine(FileIndex, "NONE")
            End If
            If UrgentOpt.Checked = True Then PrintLine(FileIndex, "HIGH")
            If NonUrgentOpt.Checked = True Then PrintLine(FileIndex, "MEDIUM")
            If InformationalLowOpt.Checked = True Then PrintLine(FileIndex, "LOW")
            PrintLine(FileIndex, MsgTxt.Lines.Length)
            PrintLine(FileIndex, MsgTxt.Text)
            PrintLine(FileIndex, ActionTxt.Lines.Length)
            If ActionTxt.Lines.Length > 0 Then PrintLine(FileIndex, ActionTxt.Text)
            If ReceivedByTxt.Text = "" Then
                PrintLine(FileIndex, "NONE")
            Else
                PrintLine(FileIndex, ReceivedByTxt.Text)
            End If
            If TimeRecTxt.Text = "" Then
                PrintLine(FileIndex, "NONE")
            Else
                PrintLine(FileIndex, TimeRecTxt.Text)
            End If
            If FwdToTxt.Text = "" Then
                PrintLine(FileIndex, "NONE")
            Else
                PrintLine(FileIndex, FwdToTxt.Text)
            End If
            PrintLine(FileIndex, CommentsTxt.Lines.Length)
            If CommentsTxt.Lines.Length > 0 Then PrintLine(FileIndex, CommentsTxt.Text)
            If FacilityTxt.Text = "" Then
                PrintLine(FileIndex, "NONE")
            Else
                PrintLine(FileIndex, FacilityTxt.Text)
            End If
            FileClose(FileIndex)
            SaveICS = True
            Exit Function
        End If
        SaveICS = False
    End Function

    Private Sub CancelMenu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CancelMenu.Click
        Call MyErase()
    End Sub

    Private Sub PrintMenu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintMenu.Click
        Dim GoodNoGood As Boolean = True

        If TextHasChanged Then GoodNoGood = SaveICS()
        If GoodNoGood = False Then Exit Sub
        TextHasChanged = False


        'MsgLine = 0
        'ActionMsgLine = 0
        'CommentsMsgLine = 0
        PrintPreviewDialog1.ShowDialog()

    End Sub

    Private Sub DateTimeMenu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DateTimeMenu.Click
        Dim MonthArray(12)
        Dim MyHour As String
        Dim MyMin As String

        MonthArray(1) = "JAN."
        MonthArray(2) = "FEB."
        MonthArray(3) = "MAR."
        MonthArray(4) = "APR."
        MonthArray(5) = "MAY."
        MonthArray(6) = "JUN."
        MonthArray(7) = "JUL."
        MonthArray(8) = "AUG."
        MonthArray(9) = "SEP."
        MonthArray(10) = "OCT."
        MonthArray(11) = "NOV."
        MonthArray(12) = "DEC."

        If DateTxt.Text = "" Then
            If DateTimeFlag = "UTC Date Time" Then
                MyHour = Date.UtcNow.Hour
                MyMin = Date.UtcNow.Minute
                If Len(MyHour) < 2 Then MyHour = "0" & MyHour
                If Len(MyMin) < 2 Then MyMin = "0" & MyMin
                TimeTxt.Text = MyHour & ":" & MyMin & "z"
                DateTxt.Text = MonthArray(Date.UtcNow.Month)
                DateTxt.AppendText(" " & Trim(Str(Date.UtcNow.Day)))
                DateTxt.AppendText("," & Trim(Str(Date.UtcNow.Year)))
            Else
                MyHour = Date.Now.Hour
                MyMin = Date.Now.Minute
                If Len(MyHour) < 2 Then MyHour = "0" & MyHour
                If Len(MyMin) < 2 Then MyMin = "0" & MyMin
                TimeTxt.Text = MyHour & ":" & MyMin
                DateTxt.Text = MonthArray(Date.Now.Month)
                DateTxt.AppendText(" " & Trim(Str(Date.Now.Day)))
                DateTxt.AppendText("," & Trim(Str(Date.Now.Year)))
            End If
        ElseIf TimeRecTxt.Text = "" Then
            If DateTimeFlag = "UTC Date Time" Then
                MyHour = Date.UtcNow.Hour
                If Len(MyHour) < 2 Then MyHour = "0" & MyHour
                MyMin = Date.UtcNow.Minute
                If Len(MyMin) < 2 Then MyMin = "0" & MyMin
                TimeRecTxt.Text = MyHour & ":" & MyMin & "z"
            Else
                MyHour = Date.Now.Hour
                If Len(MyHour) < 2 Then MyHour = "0" & MyHour
                MyMin = Date.Now.Minute
                If Len(MyMin) < 2 Then MyMin = "0" & MyMin
                TimeRecTxt.Text = MyHour & ":" & MyMin
            End If
        Else
            MsgBox("Date Received, Time Received and Time Read are already filled out. If you want to change the date and time erase one of the date time fields.", MsgBoxStyle.Information, "HICS-213 Date Time Error")
        End If
    End Sub

    Private Sub AboutMenu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutMenu.Click
        Dim Sversion As String = Mid(Me.Text, InStr(Me.Text, "V"))
        MsgBox("HICS-213 " & Sversion & vbCrLf & "By John KB2SCS" & vbCrLf & "Thank You for using HICS-213." & vbCrLf & "Please send all comments to" & vbCrLf & "kb2scs@arrl.net" & vbCrLf & "HICS-213 is distributed under the Mit license." & vbCrLf & "See source code for display of the MIT license.", MsgBoxStyle.DefaultButton1, "HICS-213 About")
    End Sub

    Private Sub HelpMenu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HelpMenu.Click
        HelpFrm.ShowDialog()
    End Sub

    Private Sub EmailMenu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EmailMenu.Click
        Dim GoodNoGood As Boolean = True

        If TextHasChanged Then GoodNoGood = SaveICS()
        If GoodNoGood = False Then Exit Sub

        Dim Sans As String
        Dim sParams As String
        Dim Sbody As String = Nothing
        Dim EmailBodyTxt As New TextBox
        Dim Shold As String = Nothing
        Static Eaddress As String

        EmailBodyTxt.WordWrap = False
        EmailBodyTxt.Multiline = True

        If UrgentOpt.Checked = True Then Shold = "URGENT"
        If NonUrgentOpt.Checked = True Then Shold = "NON URGENT"
        If InformationalLowOpt.Checked = True Then Shold = "INFORMATIONAL"

        Call FillBody(Sbody, Shold)
        'Sbody = Sbody.Replace("?", "%3F")

        Sans = InputBox("Please enter an E-Mail Address", "HICS-213 E-Mail Address Input", Eaddress)
        If Sans = Nothing Then
            Sans = "anyone@anywhere.net"
        Else
            Eaddress = Sans
        End If

        sParams = Sans
        If LCase(Strings.Left(sParams, 7)) <> "mailto:" Then _
            sParams = "mailto:" & sParams

        sParams = sParams & "?subject=" & Shold

        sParams = sParams & "&"
        sParams = sParams & "body=" & "Left Click Message area then Right Click message area and then select Paste"

        EmailBodyTxt.Text = Sbody
        EmailBodyTxt.SelectAll()
        Clipboard.Clear()
        Clipboard.SetText(EmailBodyTxt.Text)

        Try

            System.Diagnostics.Process.Start(sParams)

        Catch
            MsgBox("ERROR Could not Find a Default E-Mail CLient", MsgBoxStyle.Critical, "HICS-213 Default E-Mail Client Not Found")
        End Try

        EmailBodyTxt.Dispose()
        Call MyErase()
    End Sub

    Private Sub FillBody(ByRef Sbody As String, ByRef Shold As String)
        Dim y As Long
        Dim x As Long

        Sbody = Sbody & "***MESSAGE NUMBER:***" & vbCrLf
        Sbody = Sbody & MsgNoTxt.Text & vbCrLf
        Sbody = Sbody & "******HICS-213 MESSAGE FORM STARTS HERE******" & vbCrLf & vbCrLf
        Sbody = Sbody & "***NAME OF INCIDENT:***" & vbCrLf
        Sbody = Sbody & IncNameTxt.Text & vbCrLf & vbCrLf
        Sbody = Sbody & "***FROM:***" & vbCrLf
        Sbody = Sbody & FromTxt.Text & vbCrLf & vbCrLf
        Sbody = Sbody & "***TO:***" & vbCrLf
        Sbody = Sbody & ToTxt.Text & vbCrLf & vbCrLf
        Sbody = Sbody & "***SUBJECT:***" & vbCrLf
        Sbody = Sbody & Shold & vbCrLf & vbCrLf
        If ReplyToTxt.Text <> "" Then
            Sbody = Sbody & "***REPLY TO:***" & vbCrLf
            Sbody = Sbody & ReplyToTxt.Text & vbCrLf & vbCrLf
        End If
        Sbody = Sbody & "***PRIORITY:***" & vbCrLf
        Sbody = Sbody & Shold & vbCrLf & vbCrLf
        Sbody = Sbody & "***MESSAGE:***" & vbCrLf
        y = MsgTxt.Lines.Length
        If y > 0 Then
            For x = 0 To y - 1
                Sbody = Sbody & MsgTxt.Lines(x) & vbCrLf
            Next
        End If
        Sbody = Sbody & vbCrLf
        If ActionTxt.Text <> "" Then
            y = ActionTxt.Lines.Length
            Sbody = Sbody & "***ACTION TAKEN:***" & vbCrLf
            If y > 0 Then
                For x = 0 To y - 1
                    Sbody = Sbody & ActionTxt.Lines(x) & vbCrLf
                Next
                Sbody = Sbody & vbCrLf
            End If
        End If
        If FwdToTxt.Text <> "" Then
            Sbody = Sbody & "***FORWARD TO:***" & vbCrLf
            Sbody = Sbody & FwdToTxt.Text & vbCrLf & vbCrLf
        End If
        If CommentsTxt.Text <> "" Then
            Sbody = Sbody & "***COMMENTS:***" & vbCrLf
            y = CommentsTxt.Lines.Length
            If y > 0 Then
                For x = 0 To y - 1
                    Sbody = Sbody & CommentsTxt.Lines(x) & vbCrLf
                Next
                Sbody = Sbody & vbCrLf
            End If
        End If
        Sbody = Sbody & "***FACILITY NAME:***" & vbCrLf
        Sbody = Sbody & FacilityTxt.Text & vbCrLf & vbCrLf

    End Sub

    Private Sub TextFieldsTextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _
        IncNameTxt.TextChanged, _
        MsgNoTxt.TextChanged, _
        FromTxt.TextChanged, _
        ToTxt.TextChanged, _
        DateTxt.TextChanged, _
        TimeTxt.TextChanged, _
        ReplyToTxt.TextChanged, _
        MsgTxt.TextChanged, _
        ActionTxt.TextChanged, _
        ReceivedByTxt.TextChanged, _
        TimeRecTxt.TextChanged, _
        FwdToTxt.TextChanged, _
        CommentsTxt.TextChanged, _
        FacilityTxt.TextChanged

        TextHasChanged = True
    End Sub

    Private Sub Via(sender As Object, e As EventArgs) Handles _
        PhoneOpt.CheckedChanged, _
        RadioOpt.CheckedChanged, _
        OtherOpt.CheckedChanged

        TextHasChanged = True
    End Sub

    Private Sub ReplyYesOrNo(sender As Object, e As EventArgs) Handles _
        ReplyYesOpt.CheckedChanged, _
        ReplyNoOpt.CheckedChanged

        TextHasChanged = True
    End Sub

    Private Sub PiorityCheckedChanged(sender As Object, e As EventArgs) Handles _
        UrgentOpt.CheckedChanged, _
        NonUrgentOpt.CheckedChanged, _
        InformationalLowOpt.CheckedChanged

        TextHasChanged = True
    End Sub
    Private Sub PrintDocument1_BeginPrint(sender As Object, e As System.Drawing.Printing.PrintEventArgs) Handles PrintDocument1.BeginPrint
        Dim xHard As Single = PrintDocument1.DefaultPageSettings.HardMarginX
        Dim yHard As Single = PrintDocument1.DefaultPageSettings.HardMarginY


        PrintDocument1.DefaultPageSettings.Margins.Right = 25
        PrintDocument1.DefaultPageSettings.Margins.Bottom = 70
        If PrintDocument1.PrintController.IsPreview Then
            PrintDocument1.DefaultPageSettings.Margins.Left = xHard + 25
            PrintDocument1.DefaultPageSettings.Margins.Top = yHard + 25
        Else
            PrintDocument1.DefaultPageSettings.Margins.Left = 25
            PrintDocument1.DefaultPageSettings.Margins.Top = 25
        End If

    End Sub

    Private Sub PrintDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage
        Dim PrFont As New Font("Courier New", 8, FontStyle.Regular, GraphicsUnit.Point)
        Dim PrFontSmall As New Font("Courier New", 7, FontStyle.Regular, GraphicsUnit.Point)
        Dim PrFontBold As New Font("Courier New", 9, FontStyle.Bold, GraphicsUnit.Point)
        Dim intPrintAreaHeight, intPrintAreaWidth, marginLeft, marginTop As Int32
        Dim PrintAreaX As Integer = CInt(PrintDocument1.DefaultPageSettings.PrintableArea.X)
        Dim PrintAreaY As Integer = CInt(PrintDocument1.DefaultPageSettings.PrintableArea.Y)
        Dim PrintAreaW As Integer = CInt(PrintDocument1.DefaultPageSettings.PrintableArea.Width) - PrintDocument1.DefaultPageSettings.Margins.Right
        Dim PrintAreaH As Integer = CInt(PrintDocument1.DefaultPageSettings.PrintableArea.Height) - PrintDocument1.DefaultPageSettings.Margins.Bottom
        Static MsgintCurrentChar As Int32
        Static ActintCurrentChar As Int32
        Static ComintCurrentChar As Int32

        e.HasMorePages = False
        e.Graphics.DrawRectangle(Pens.Black, 0, 0, PrintAreaW, PrintAreaH)
        e.Graphics.DrawString("HICS 213 - INCIDENT MESSAGE FORM", PrFontBold, Brushes.Black, 5, 10)
        e.Graphics.DrawLine(Pens.Black, 0, 25, PrintAreaW, 25)
        e.Graphics.DrawString("1.FROM(Sender):", PrFontBold, Brushes.Black, 5, 30)
        e.Graphics.DrawString("2.TO(Receiver):", PrFontBold, Brushes.Black, 365, 30)
        e.Graphics.DrawLine(Pens.Black, 0, 45, PrintAreaW, 45)
        e.Graphics.DrawString("3.DATE RECEIVED", PrFontBold, Brushes.Black, 5, 50)
        e.Graphics.DrawLine(Pens.Black, 125, 45, 125, 102)
        e.Graphics.DrawString("4.TIME RECEIVED", PrFontBold, Brushes.Black, 125, 50)
        e.Graphics.DrawString("5.RECEIVED VIA", PrFontBold, Brushes.Black, 250, 50)
        e.Graphics.DrawString("6.REPLY REQUESTED:", PrFontBold, Brushes.Black, 365, 50)
        e.Graphics.DrawRectangle(Pens.Black, 250, 70, 10, 10)
        e.Graphics.DrawString("PHONE", PrFontBold, Brushes.Black, 260, 67)
        e.Graphics.DrawRectangle(Pens.Black, 305, 70, 10, 10)
        e.Graphics.DrawString("RADIO", PrFontBold, Brushes.Black, 315, 67)
        e.Graphics.DrawRectangle(Pens.Black, 250, 90, 10, 10)
        e.Graphics.DrawString("OTHER", PrFontBold, Brushes.Black, 260, 87)
        e.Graphics.DrawRectangle(Pens.Black, 370, 70, 10, 10)
        e.Graphics.DrawString("YES", PrFontBold, Brushes.Black, 380, 67)
        e.Graphics.DrawRectangle(Pens.Black, 410, 70, 10, 10)
        e.Graphics.DrawString("NO", PrFontBold, Brushes.Black, 421, 67)
        e.Graphics.DrawLine(Pens.Black, 0, 102, PrintAreaW, 102)
        e.Graphics.DrawLine(Pens.Black, 363, 30, 363, 102)
        e.Graphics.DrawString("7.PRIORITY", PrFontBold, Brushes.Black, 5, 107)
        e.Graphics.DrawRectangle(Pens.Black, 150, 112, 10, 10)
        e.Graphics.DrawString("Urgent-High", PrFontBold, Brushes.Black, 160, 109)
        e.Graphics.DrawRectangle(Pens.Black, 300, 112, 10, 10)
        e.Graphics.DrawString("Non Urgent-Medium", PrFontBold, Brushes.Black, 310, 109)
        e.Graphics.DrawRectangle(Pens.Black, 500, 112, 10, 10)
        e.Graphics.DrawString("Informational-Low", PrFontBold, Brushes.Black, 510, 109)
        e.Graphics.DrawLine(Pens.Black, 0, 129, PrintAreaW, 129)
        e.Graphics.DrawString("8.MESSAGE (KEEP ALL MESSAGES/REQUESTS BREIF, TO THE POINT, AND VERY SPECIFIC):", PrFontBold, Brushes.Black, 5, 134) 'TOP OF MESSAGE PRINT AREA
        e.Graphics.DrawLine(Pens.Black, 0, 500, PrintAreaW, 500)
        e.Graphics.DrawString("9.ACTION TAKEN (If any):", PrFontBold, Brushes.Black, 5, 505) 'TOP OF ACTION PRINT AREA
        e.Graphics.DrawLine(Pens.Black, 0, 700, PrintAreaW, 700)
        e.Graphics.DrawString("Rec. by:", PrFontBold, Brushes.Black, 5, 705)
        e.Graphics.DrawString("Time Received:", PrFontBold, Brushes.Black, 305, 705)
        e.Graphics.DrawString("FWD. To:", PrFontBold, Brushes.Black, 460, 705)
        e.Graphics.DrawLine(Pens.Black, 0, 725, PrintAreaW, 725)
        e.Graphics.DrawString("COMMENTS:", PrFontBold, Brushes.Black, 5, 730) 'TOP OF COMMENTS PRINT AREA
        e.Graphics.DrawLine(Pens.Black, 0, 900, PrintAreaW, 900)
        e.Graphics.DrawString("10.FACILITY NAME", PrFontBold, Brushes.Black, 5, 905)
        e.Graphics.DrawLine(Pens.Black, 0, 920, PrintAreaW, 920)
        e.Graphics.DrawString("Purpose: Provide standardized method for recording messages received by phone or radio Orgination All Positions.      HICS 213", PrFontSmall, Brushes.Black, 5, 930)
        e.Graphics.DrawString("Original to receiver. Copies To: Documention Unit Leader and Message Taker", PrFontSmall, Brushes.Black, 5, 940)
        e.Graphics.DrawString("May 2008                                                                   2-1 * HICS 213 Incident Message Form", PrFontSmall, Brushes.Black, 5, 950)

        If IncNameTxt.Text <> "" Then e.Graphics.DrawString(IncNameTxt.Text, PrFont, Brushes.Black, 275, 10)
        e.Graphics.DrawString(FromTxt.Text, PrFont, Brushes.Black, 120, 30)
        e.Graphics.DrawString(ToTxt.Text, PrFont, Brushes.Black, 480, 30)
        e.Graphics.DrawString(DateTxt.Text, PrFont, Brushes.Black, 20, 70)
        e.Graphics.DrawString(TimeTxt.Text, PrFont, Brushes.Black, 140, 70)
        If PhoneOpt.Checked = True Then e.Graphics.DrawString("X", PrFont, Brushes.Black, 250, 68) 'PHONE X
        If RadioOpt.Checked = True Then e.Graphics.DrawString("X", PrFont, Brushes.Black, 305, 68) 'RADIO X
        If OtherOpt.Checked = True Then e.Graphics.DrawString("X", PrFont, Brushes.Black, 250, 88) 'OTHER X
        If ReplyYesOpt.Checked = True Then e.Graphics.DrawString("X", PrFont, Brushes.Black, 370, 68) 'REPLY YES X
        If ReplyNoOpt.Checked = True Then e.Graphics.DrawString("X", PrFont, Brushes.Black, 410, 68) 'REPLY NO X
        If ReplyToTxt.Text <> "" Then e.Graphics.DrawString(ReplyToTxt.Text, PrFont, Brushes.Black, 365, 80)
        If UrgentOpt.Checked = True Then e.Graphics.DrawString("X", PrFont, Brushes.Black, 150, 110) 'URGENT X
        If NonUrgentOpt.Checked = True Then e.Graphics.DrawString("X", PrFont, Brushes.Black, 300, 110) 'NON URGENT X
        If InformationalLowOpt.Checked = True Then e.Graphics.DrawString("X", PrFont, Brushes.Black, 500, 110) 'INFORMATIONAL X
        If ReceivedByTxt.Text <> "" Then e.Graphics.DrawString(ReceivedByTxt.Text, PrFont, Brushes.Black, 70, 705)
        If TimeRecTxt.Text <> "" Then e.Graphics.DrawString(TimeRecTxt.Text, PrFont, Brushes.Black, 415, 705)
        If FwdToTxt.Text <> "" Then e.Graphics.DrawString(FwdToTxt.Text, PrFontBold, Brushes.Black, 525, 705)
        If FacilityTxt.Text <> "" Then e.Graphics.DrawString(FacilityTxt.Text, PrFont, Brushes.Black, 135, 905)

        intPrintAreaHeight = 490 - 150
        intPrintAreaWidth = PrintAreaW - 5
        marginLeft = 5
        marginTop = 150
        Dim intLineCount As Int32 = CInt(intPrintAreaHeight / PrFont.Height)
        Dim rectPrintingArea As New RectangleF(marginLeft, marginTop, intPrintAreaWidth, intPrintAreaHeight)
        Dim fmt As New StringFormat(StringFormatFlags.LineLimit)
        Dim intLinesFilled, intCharsFitted As Int32
        e.Graphics.MeasureString(Mid(MsgTxt.Text, MsgintCurrentChar + 1), PrFont, _
                    New SizeF(intPrintAreaWidth, intPrintAreaHeight), fmt, _
                    intCharsFitted, intLinesFilled)

        If MsgintCurrentChar + intCharsFitted < MsgTxt.Text.Length Then
            If MsgTxt.Text.Substring(MsgintCurrentChar + intCharsFitted, 1) <> " " And _
                        MsgTxt.Text.Substring(MsgintCurrentChar + intCharsFitted, 1) <> vbLf Then
                ' As long as the last character is not space or carriage return, 
                ' keep subtracting another character from the text to be printed.
                While intCharsFitted > 0 AndAlso _
                            MsgTxt.Text.Substring(MsgintCurrentChar + intCharsFitted, 1) <> " " AndAlso _
                            MsgTxt.Text.Substring(MsgintCurrentChar + intCharsFitted, 1) <> vbLf
                    intCharsFitted -= 1
                End While
                intCharsFitted += 1
            End If
        End If

        ' Print the text to the page.
        e.Graphics.DrawString(MsgTxt.Text.Substring(MsgintCurrentChar, intCharsFitted), PrFont, _
            Brushes.Black, rectPrintingArea, fmt)
        MsgintCurrentChar = MsgintCurrentChar + intCharsFitted

        If MsgintCurrentChar < MsgTxt.Text.Length Then e.HasMorePages = True


        intPrintAreaHeight = 705 - 520
        intPrintAreaWidth = PrintAreaW - 5
        marginLeft = 5
        marginTop = 520
        intLineCount = CInt(intPrintAreaHeight / PrFont.Height)
        rectPrintingArea = New RectangleF(marginLeft, marginTop, intPrintAreaWidth, intPrintAreaHeight)
        fmt = New StringFormat(StringFormatFlags.LineLimit)

        e.Graphics.MeasureString(Mid(ActionTxt.Text, ActintCurrentChar + 1), PrFont, _
                    New SizeF(intPrintAreaWidth, intPrintAreaHeight), fmt, _
        intCharsFitted, intLinesFilled)

        If ActintCurrentChar + intCharsFitted < ActionTxt.Text.Length Then
            If ActionTxt.Text.Substring(ActintCurrentChar + intCharsFitted, 1) <> " " And _
                        ActionTxt.Text.Substring(ActintCurrentChar + intCharsFitted, 1) <> vbLf Then
                ' As long as the last character is not space or carriage return, 
                ' keep subtracting another character from the text to be printed.
                While intCharsFitted > 0 AndAlso _
                            ActionTxt.Text.Substring(ActintCurrentChar + intCharsFitted, 1) <> " " AndAlso _
                            ActionTxt.Text.Substring(ActintCurrentChar + intCharsFitted, 1) <> vbLf
                    intCharsFitted -= 1
                End While
                intCharsFitted += 1
            End If
        End If

        ' Print the text to the page.
        e.Graphics.DrawString(ActionTxt.Text.Substring(ActintCurrentChar, intCharsFitted), PrFont, _
            Brushes.Black, rectPrintingArea, fmt)
        ActintCurrentChar = ActintCurrentChar + intCharsFitted

        If ActintCurrentChar < ActionTxt.Text.Length Then e.HasMorePages = True


        intPrintAreaHeight = 900 - 745
        intPrintAreaWidth = PrintAreaW - 5
        marginLeft = 5
        marginTop = 745
        intLineCount = CInt(intPrintAreaHeight / PrFont.Height)
        rectPrintingArea = New RectangleF(marginLeft, marginTop, intPrintAreaWidth, intPrintAreaHeight)
        fmt = New StringFormat(StringFormatFlags.LineLimit)

        e.Graphics.MeasureString(Mid(CommentsTxt.Text, ComintCurrentChar + 1), PrFont, _
                    New SizeF(intPrintAreaWidth, intPrintAreaHeight), fmt, _
        intCharsFitted, intLinesFilled)

        If ComintCurrentChar + intCharsFitted < CommentsTxt.Text.Length Then
            If CommentsTxt.Text.Substring(ComintCurrentChar + intCharsFitted, 1) <> " " And _
                        CommentsTxt.Text.Substring(ComintCurrentChar + intCharsFitted, 1) <> vbLf Then
                ' As long as the last character is not space or carriage return, 
                ' keep subtracting another character from the text to be printed.
                While intCharsFitted > 0 AndAlso _
                            CommentsTxt.Text.Substring(ComintCurrentChar + intCharsFitted, 1) <> " " AndAlso _
                            CommentsTxt.Text.Substring(ComintCurrentChar + intCharsFitted, 1) <> vbLf
                    intCharsFitted -= 1
                End While
                intCharsFitted += 1
            End If
        End If

        ' Print the text to the page.
        e.Graphics.DrawString(CommentsTxt.Text.Substring(ComintCurrentChar, intCharsFitted), PrFont, _
            Brushes.Black, rectPrintingArea, fmt)
        ComintCurrentChar = ComintCurrentChar + intCharsFitted

        If ComintCurrentChar < CommentsTxt.Text.Length Then e.HasMorePages = True

        If e.HasMorePages = False Then
            MsgintCurrentChar = 0
            ActintCurrentChar = 0
            ComintCurrentChar = 0
        End If

    End Sub

    Private Sub SetupMenu_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SetupMenu.Click
        Dim FileIndex As Integer

        UtcLocalFrm.ShowDialog()
        Select Case UtcLocalFrm.DialogResult
            Case DialogResult.Yes  'UTC
                DateTimeFlag = "UTC Date Time"
            Case DialogResult.No  'LOCAL
                DateTimeFlag = "LOCAL Date Time"
        End Select
        FileIndex = FreeFile()
        FileOpen(FileIndex, DataDirPath & "\HICS.ini", OpenMode.Output)
        PrintLine(FileIndex, "015")
        PrintLine(FileIndex, DateTimeFlag)
        FileClose(FileIndex)
    End Sub
    Private Sub RmsExpressMenu_Click(sender As System.Object, e As System.EventArgs) Handles RMSExpressMenu.Click
        Dim GoodNoGood As Boolean = True

        If TextHasChanged Then GoodNoGood = SaveICS()
        If GoodNoGood = False Then Exit Sub

        Dim Sans As String
        Dim Sbody As String = Nothing
        Dim FileIndex As Short
        Dim Dans As DialogResult
        Dim AtFile As String = Nothing
        Dim Shold As String = Nothing
        Static Eaddress As String

        If Not My.Computer.FileSystem.DirectoryExists(DataDirPath & "\RmsExpress") Then _
          My.Computer.FileSystem.CreateDirectory(DataDirPath & "\RmsExpress")

        If UrgentOpt.Checked = True Then Shold = "URGENT"
        If NonUrgentOpt.Checked = True Then Shold = "NON URGENT"
        If InformationalLowOpt.Checked = True Then Shold = "INFORMATIONAL"

        Call FillBody(Sbody, Shold)

        Sans = InputBox("Please enter an E-Mail Address", "HICS-213 E-Mail Address Input", Eaddress)
        If Sans = Nothing Then
            Sans = "anyone@anywhere.net"
        Else
            Eaddress = Sans
        End If

        Dans = MsgBox("Is the recipient of this E-Mail using HICS-213?" & vbCrLf & "Answering Yes will cause HICS-213 to attach the .ICS file." & vbCrLf & "Answering No the .ICS file will not be attached.", MsgBoxStyle.YesNo, "HICS-213 Attach .ICS File Question")
        If Dans = Windows.Forms.DialogResult.Yes Then
            AtFile = AttchFileNamePath
        Else
            AtFile = Nothing
        End If
        Sbody = "Msg:" & vbCrLf & Sbody
        If AtFile <> Nothing Then Sbody = "Attach:" & AttchFileNamePath & vbCrLf & Sbody
        Sbody = "Subj:" & Shold & vbCrLf & Sbody
        Sbody = "To:" & Sans & vbCrLf & Sbody
        Sbody = "Type:Winlink" & vbCrLf & Sbody

        FileIndex = FreeFile()
        FileOpen(FileIndex, DataDirPath & "\RmsExpress\ICS-213.txt", OpenMode.Output)
        PrintLine(FileIndex, Sbody)
        FileClose(FileIndex)

        MsgBox("RMS Express Template file successfully saved to " & DataDirPath & "\RmsExpress\ICS-213.txt" & vbCrLf & "Use the RMS Express Template feature to send your ICS form." & vbCrLf & "Note you can add as an attachment the .ICS file if your recipient is using HICS-213", MsgBoxStyle.DefaultButton1, "HICS-213 RMS Express Template")


        Call MyErase()

    End Sub

End Class
